--- a/NEWS	2020-12-14 15:07:19.499710089 +0100
+++ b/NEWS	2020-12-14 15:07:46.679343906 +0100
@@ -21,6 +21,10 @@
 * ip-tunnel: only set cloned-mac-address for layer 2 tunnels.
 * Fixes for sanitizer build and valgrind.
 * Various other bugfixes.
+* Wi-Fi profiles now also autoconnect if all previous activation attempts
+  failed. This means, an initial failure to autoconnect to the network will
+  no longer block the automatism. A side effect is that existing Wi-Fi profiles
+  which previously were blocked may now start to autoconnect.
 
 =============================================
 NetworkManager-1.24
--- a/src/settings/nm-settings-connection.c	2020-12-14 15:19:57.466129899 +0100
+++ b/src/settings/nm-settings-connection.c	2020-12-14 15:26:13.825035028 +0100
@@ -2136,15 +2136,24 @@
 nm_settings_connection_update_timestamp (NMSettingsConnection *self,
                                          guint64 timestamp)
 {
-	NMSettingsConnectionPrivate *priv = NM_SETTINGS_CONNECTION_GET_PRIVATE (self);
+	NMSettingsConnectionPrivate *priv;
 	const char *connection_uuid;
 	char sbuf[60];
 
 	g_return_if_fail (NM_IS_SETTINGS_CONNECTION (self));
 
+	priv = NM_SETTINGS_CONNECTION_GET_PRIVATE (self);
+
+	if (   priv->timestamp == timestamp
+	    && priv->timestamp_set)
+		return;
+
 	priv->timestamp = timestamp;
 	priv->timestamp_set = TRUE;
 
+	_LOGT ("timestamp: set timestamp %"G_GUINT64_FORMAT,
+	       timestamp);
+
 	if (!priv->kf_db_timestamps)
 		return;
 
@@ -2185,10 +2194,10 @@
 		if (timestamp != G_MAXUINT64) {
 			priv->timestamp = timestamp;
 			priv->timestamp_set = TRUE;
-			_LOGT ("read timestamp %"G_GUINT64_FORMAT" from keyfile database \"%s\"",
+			_LOGT ("timestamp: read timestamp %"G_GUINT64_FORMAT" from keyfile database \"%s\"",
 			       timestamp, nm_key_file_db_get_filename (priv->kf_db_timestamps));
 		} else
-			_LOGT ("no timestamp from keyfile database \"%s\"",
+			_LOGT ("timestamp: no timestamp from keyfile database \"%s\"",
 			       nm_key_file_db_get_filename (priv->kf_db_timestamps));
 	}
 
--- a/src/devices/wifi/nm-device-wifi.c	2020-12-14 15:08:13.238986895 +0100
+++ b/src/devices/wifi/nm-device-wifi.c	2020-12-14 15:08:55.682416378 +0100
@@ -1287,7 +1287,6 @@
 	NMWifiAP *ap;
 	const char *method6, *mode;
 	gboolean auto4, auto6;
-	guint64 timestamp = 0;
 
 	nm_assert (!specific_object || !*specific_object);
 
@@ -1315,15 +1314,6 @@
 	else if (!auto4 && !auto6 && nm_streq0 (mode, NM_SETTING_WIRELESS_MODE_MESH))
 		return TRUE;
 
-	/* Don't autoconnect to networks that have been tried at least once
-	 * but haven't been successful, since these are often accidental choices
-	 * from the menu and the user may not know the password.
-	 */
-	if (nm_settings_connection_get_timestamp (sett_conn, &timestamp)) {
-		if (timestamp == 0)
-			return FALSE;
-	}
-
 	ap = nm_wifi_aps_find_first_compatible (&priv->aps_lst_head, connection);
 	if (ap) {
 		/* All good; connection is usable */
--- a/src/nm-manager.c	2020-12-14 15:16:52.336607769 +0100
+++ b/src/nm-manager.c	2020-12-14 15:19:19.542644873 +0100
@@ -7343,12 +7343,19 @@
 	NMManager *manager = NM_MANAGER (user_data);
 	NMManagerPrivate *priv = NM_MANAGER_GET_PRIVATE (manager);
 	NMActiveConnection *ac;
+	gboolean has_time = FALSE;
+	guint64 t;
 
 	c_list_for_each_entry (ac, &priv->active_connections_lst_head, active_connections_lst) {
-		if (nm_active_connection_get_state (ac) == NM_ACTIVE_CONNECTION_STATE_ACTIVATED) {
-			nm_settings_connection_update_timestamp (nm_active_connection_get_settings_connection (ac),
-			                                         (guint64) time (NULL));
+		if (nm_active_connection_get_state (ac) != NM_ACTIVE_CONNECTION_STATE_ACTIVATED)
+			continue;
+
+		if (!has_time) {
+			t = time (NULL);
+			has_time = TRUE;
 		}
+		nm_settings_connection_update_timestamp (nm_active_connection_get_settings_connection (ac),
+		                                         t);
 	}
 	return G_SOURCE_CONTINUE;
 }
